{-------------------------------------------------------------}
{
{    Webvox - Mdulo de configurao
{
{    Autor: Jose Antonio Borges
{
{    Em 18/12/99
{
{-------------------------------------------------------------}

unit webConf;

interface
uses dvcrt, dvWin, sysUtils, dvInet, dvForm, winsock,
     webVars, webMsg, Windows;

procedure configura;
procedure trocaLingua;

implementation

{-------------------------------------------------------------}
{                   troca o sintetizador Sapi
{-------------------------------------------------------------}

procedure trocaLingua;
begin
    emPortug := not emPortug;
    if emPortug then
        begin
            mensagem ('WBLEORIG',1);    {Lendo com sntese original}
            sintReinic (velocAtual, usaSapi, tipoSapi1, vozSapi1, velSapi1, tomSapi1);
        end
    else
        begin
            mensagem ('WBLEALT',1);    {Lendo com a sntese alternativa}
            sintReinic (velocAtual, true, tipoSapi2, vozSapi2, velSapi2, tomSapi2);
        end;
end;

{-------------------------------------------------------------}
{                   configura o programa
{-------------------------------------------------------------}

procedure configura;
var
    vel: integer;
    s: string;
    sz: array [0..144] of char;
    mf,  hProxy, xProxy: shortString;
    arqBuscador, dirBuscador: shortString;
    editor: shortString;
begin
    clrscr;
    writeln ('WEBVOX');
    mensagem ('WBSETCNF', 2);   {'Use as setas, editore as configuraes e depois tecle ESC'}

    mf := modoFala;
    vel := velocAtual;

    tamRotulosForm := 45;
    formCria;
    formCampoInt  ('WBVELFAL', pegaTextoMensagem('WBVELFAL'), vel);
                                {'Qual a velocidade de fala ? De 1 a 5 '}
    formCampoBool ('WBFALAPT', pegaTextoMensagem('WBFALAPT'), falandoPontuacao);
                                {'Fala pontuao ? '}
    formCampo     ('WBNIVINF', pegaTextoMensagem ('WBNIVINF'), mf, 1);
                                {'Nvel textual, resumido, normal ou detalhado'}
    formCampoInt  ('WBTIPSAP', pegaTextoMensagem ('WBTIPSAP'), tipoSapi2);
                                {'Tipo SAPI (4 ou 5) da lngua alternativa'}
    formCampoInt  ('WBSAPALT', pegaTextoMensagem ('WBSAPALT'), vozSapi2);
                                {'Voz sapi da lngua alternativa'}
    formCampoInt  ('WBVELALT', pegaTextoMensagem ('WBVELALT'), velSapi2);
                                {'Velocidade da lngua alternativa'}
    formCampoInt  ('WBTOMALT', pegaTextoMensagem ('WBTOMALT'), tomSapi2);
                                {'Tonalidade da lngua alternativa'}

    formCampoBool ('WBCOMPXY', pegaTextoMensagem('WBCOMPXY'), comProxy);
                                {'Sua conexo utiliza um proxy?'}
    hProxy := hostProxy;
    formCampo     ('WBENDPXY', pegaTextoMensagem('WBENDPXY'), hProxy, 40);
                                {'Endereo do Proxy'}
    formCampoInt  ('WBPORPXY', pegaTextoMensagem('WBPORPSY'), portaProxy);
                                {'Porta do Proxy'}
    xProxy := arqExcProxy;
    formCampo     ('WBEXCPXY', pegaTextoMensagem('WBEXCPXY'), xProxy, 80);
                                {'Arquivo de excesses de proxy'}

    editor := sintAmbiente ('WEBVOX', 'EDITOR');
    if editor = '' then
        editor := sintAmbiente ('DOSVOX', 'MINIED');
    formCampo     ('WBEDITOR', pegaTextoMensagem('WBEDITOR'), editor, 128);
                                {'Editor de textos'}

    arqBuscador := sintAmbiente ('WEBVOX', 'ARQBUSCADOR');
    formCampo     ('WBCARQBU', pegaTextoMensagem('WBCARQBU'), arqBuscador, 128);
                                {'Arquivo de pginas do Buscador'}

    dirBuscador := sintAmbiente ('WEBVOX', 'DIRBUSCADOR');
    formCampo     ('WBCDIRBU', pegaTextoMensagem('WBCDIRBU'), dirBuscador, 128);
                                {'Diretrio do Buscador'}

    formEdita (true);

    if vel in [1..5] then
        begin
            sintFim;
            sintInic (vel, sintambiente ('WEBVOX', 'DIRWEBVOX'));
        end;

    mf := mf + 'N';
    modoFala := upcase(mf[1]);
    case modoFala of
       'T', 'R':
              prepSonsTags ('');

       'N':   begin
                  s := sintAmbiente ('WEBVOX', 'AMBWEBTAGS');
                  if s = '' then s := 'c:\winvox\webtags.ini';
                  prepSonsTags (s);
              end;
       'D':   begin
                  s := sintAmbiente ('WEBVOX', 'AMBWEBTAGS2');
                  if s = '' then s := 'c:\winvox\webtags2.ini';
                  prepSonsTags (s);
              end;
    end;

    str (tipoSapi2, s);
    strPCopy (sz, s);
    writePrivateProfileString('WEBVOX', 'TIPOSAPI', sz, 'DOSVOX.INI');
    str (vozSapi2, s);
    strPCopy (sz, s);
    writePrivateProfileString('WEBVOX', 'VOZSAPI', sz, 'DOSVOX.INI');
    str (velSapi2, s);
    strPCopy (sz, s);
    writePrivateProfileString('WEBVOX', 'VELOCSAPI', sz, 'DOSVOX.INI');
    str (tomSapi2, s);
    strPCopy (sz, s);
    writePrivateProfileString('WEBVOX', 'TOMSAPI', sz, 'DOSVOX.INI');

    if comProxy then strPCopy (sz, 'SIM')
                else strPCopy (sz, 'NO');
    writePrivateProfileString('WEBVOX', 'COMPROXY', sz, 'DOSVOX.INI');

    hostProxy := hProxy;
    strPCopy (sz, hProxy);
    writePrivateProfileString('WEBVOX', 'ENDERPROXY', sz, 'DOSVOX.INI');

    str (portaProxy, s);
    strPCopy (sz, s);
    writePrivateProfileString('WEBVOX', 'PORTAPROXY', sz, 'DOSVOX.INI');

    arqExcProxy := xProxy;
    strPCopy (sz, arqExcProxy);
    writePrivateProfileString('WEBVOX', 'SITESSEMPROXY', sz, 'DOSVOX.INI');

    strPCopy (sz, editor);
    writePrivateProfileString('WEBVOX', 'EDITOR', sz, 'DOSVOX.INI');
    strPCopy (sz, arqBuscador);
    writePrivateProfileString('WEBVOX', 'ARQBUSCADOR', sz, 'DOSVOX.INI');
    strPCopy (sz, dirBuscador);
    writePrivateProfileString('WEBVOX', 'DIRBUSCADOR', sz, 'DOSVOX.INI');
end;

end.
