unit webutil;

interface
uses SysUtils;

procedure netDebug (s: pchar; tam: integer);
function maiorData (data1, data2: string): integer;
procedure limpaArq;
function HexToInt(Palavra: string): Word;
function dataToInt (data: string): longword;
function maiusc (s: string): string;
function editaSenha (var s: string): char;
function codFraseMime64 (bloco: string): string;
function base64 (bloco: string): string;
function UrlEnc(s: String): String;

implementation
uses webvars, dvcrt, dvwin;

{-------------------------------------------------------------}
{                  codifica uma frase em mime64
{-------------------------------------------------------------}

const
    MIME64: array [0..63] of char =
       'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/';

function codFraseMime64 (bloco: string): string;
var
   s: string;
   lidos, guarda: integer;
   byteEnt: byte;
   noBloco, indBloco: integer;

begin
   lidos := 0;
   s := '';
   noBloco := length (bloco);
   indBloco := 1;
   guarda := 0;

   while noBloco <> 0 do
       begin
           byteEnt := ord(bloco [indBloco]);
           indBloco := indBloco + 1;
           noBloco := noBloco - 1;

           case lidos of
               0: begin
                      s := s + MIME64[byteEnt shr 2];
                      guarda := (byteEnt and 3) shl 4;
                  end;
               1: begin
                      s := s + MIME64[((byteEnt shr 4) and $f) or guarda];
                      guarda := (byteEnt and $f) shl 2;
                  end;
               2: begin
                      s := s + MIME64[((byteEnt shr 6) and $3) or guarda];
                      guarda := byteEnt and $3f;
                      s := s + MIME64[guarda];
                  end;
           end;
           lidos := (lidos + 1) mod 3;
       end;

   if lidos <> 0 then
       s := s + MIME64[guarda];

    while (length (s) mod 4) <> 0 do
        s := s + '=';

    codFraseMime64 := s;
end;

{-------------------------------------------------------------}
{                     edita uma senha
{-------------------------------------------------------------}

function editaSenha (var s: string): char;
var c: char;
    i: integer;
label sai;
begin
    gotoxy (1, wherey);
    for i := 1 to length (s) do write ('*');
    s := '';

    repeat
        gotoxy (length(s) + 1, wherey);
        c := readkey;
        {sintclek;   Bernard}
        if (c = #$0) then
            begin
                c := readkey ;
                goto sai;
            end;
        if (c = ESC) or (c = ENTER) then goto sai;
        if c = BS then
            delete (s, length(s), 1)
        else
            s := s + c;
    until false;

sai:
    editaSenha := c;
end;

{---------------------------------------------------------------}
{           retorna qual a maior dadta entre as duas
{---------------------------------------------------------------}

function maiorData (data1, data2: string): integer;
begin
   if dataToInt (data1) > dataToInt (data2) then
      result := 1
   else
      result := 2;
end;

{-------------------------------------------------------------}
{                      escreve texto de debug
{-------------------------------------------------------------}

procedure netDebug (s: pchar; tam: integer);
begin
    if not debug then exit;
    textBackGround (BROWN);
    write ('>>>');
    writebuf (s, tam);
    textBackGround (BLACK);
end;

{----------------------------------------------------------}
{        limpa os cookies temporarios (sem data)
{        ou com data antiga
{----------------------------------------------------------}

procedure limpaArq;
var
//   continua: boolean;
   i, j: integer;
   s: string;
begin
//   continua := true;
   i := 0;
   while true do
      begin
          if i > ArquivoDeCookies.Count-1 then
             break;

          s := ArquivoDeCookies [i];
          if pos ('dominio',s) = 0 then
             begin
                i := i + 1;
                continue;
             end;

          s := ArquivoDeCookies [i+4];
          delete (s, 1, length ('tempo='));

          if (s = '') or (pos ('1970', s) <> 0) then   // mudar para comparar data
             for j := i to i + 7 do
                ArquivoDeCookies.Delete(i-1)
          else
             i := i + 7;
      end;
end;

function HexToInt(Palavra: string): Word;
var Indice, Num: Word;
begin
   while (Palavra <> '') and (Palavra[1] = ' ') do Delete(Palavra,1,1);
   while (Palavra <> '') and (Palavra[Length(Palavra)] = ' ') do Delete(Palavra,Length(Palavra),1);
   if Palavra[Length(Palavra)] = 'H' then Delete(Palavra,Length(Palavra),1)
   else if Palavra[1] = '$' then Delete(Palavra,1,1);
   Result := 0;
   for Indice := Length(Palavra) downto 1 do begin
      Case Palavra[Indice] of
      'A'..'F' : Num := Ord (Palavra [Indice]) - 55;
      'a'..'f' : Num := Ord (Palavra [indice]) - 87;
      '0'..'9' : Num := StrToInt (Palavra[Indice]);
      else Num :=0;
      end;
      Result := trunc(Result + Exp((Length(Palavra)-Indice)*Ln(16))*Num);
   end;

end;

function dataToInt (data: string): longword;
var
   posicao: integer;
   dd: integer;
   mm: integer;
   aa: integer;
   erro: integer;
   dataint: longword;
   mes: string;
begin
   posicao := pos ('-',data);
   while posicao <> 0 do
      begin
         data [posicao] := ' ';
         posicao := pos ('-', data);
      end;

   posicao := pos (' ', data);
   delete (data, 1, posicao);

   posicao := pos (' ', data);
   val (copy (data,1,posicao), dd, erro);
   delete (data, 1, posicao);

   posicao := pos (' ', data);
   mes := copy (data,1,posicao-1);
   delete (data, 1, posicao);

   posicao := pos (' ', data);
   val (copy (data,1,posicao), aa, erro);

   mm := 0;
   if maiusc (mes) = 'JAN' then mm := 101
   else if maiusc (mes) = 'FEB' then mm := 102
   else if maiusc (mes) = 'MAR' then mm := 103
   else if maiusc (mes) = 'APR' then mm := 104
   else if maiusc (mes) = 'MAY' then mm := 105
   else if maiusc (mes) = 'JUN' then mm := 106
   else if maiusc (mes) = 'JUL' then mm := 107
   else if maiusc (mes) = 'AGU' then mm := 108
   else if maiusc (mes) = 'SEP' then mm := 109
   else if maiusc (mes) = 'OCT' then mm := 110
   else if maiusc (mes) = 'NOV' then mm := 111
   else if maiusc (mes) = 'DEC' then mm := 112;


   dataint := aa * 100000 + mm * 100 + dd;

   result := dataint;
end;

function maiusc (s: string): string;
var
   tam, i: integer;
begin
   tam := length (s);
   for i := 1 to tam do
      s [i] := upcase (s [i]);

   result := s;
end;

{-------------------------------------------------------------}
{                  transforma cadeia em base 64
{-------------------------------------------------------------}

function base64 (bloco: string): string;
const
    MIME64: array [0..63] of char =
       'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/';
var
   lidos, guarda: integer;
   byteEnt: byte;
   s: string [80];
   indBloco: integer;

label erro;

begin
   lidos := 0;
   s := '';
   guarda := 0;

   for indBloco := 1 to length (bloco) do
       begin
           byteEnt := ord(bloco [indBloco]);
           case lidos of
               0: begin
                      s := s + MIME64[byteEnt shr 2];
                      guarda := (byteEnt and 3) shl 4;
                  end;
               1: begin
                      s := s + MIME64[((byteEnt shr 4) and $f) or guarda];
                      guarda := (byteEnt and $f) shl 2;
                  end;
               2: begin
                      s := s + MIME64[((byteEnt shr 6) and $3) or guarda];
                      guarda := byteEnt and $3f;
                      s := s + MIME64[guarda];
                  end;
           end;

           lidos := (lidos + 1) mod 3;
       end;

   if lidos <> 0 then
       s := s + MIME64[guarda];

    while (length (s) mod 4) <> 0 do
        s := s + '=';

    base64 := s;
end;

{-------------------------------------------------------------}
{                muda nome quando acentuado
{-------------------------------------------------------------}

function UrlEnc(s: String): String;
var i: Integer;
begin
    Result := '';
    for i := 1 to length(s) do
        begin
            if s[i] = ' ' then
                Result := Result + '%20'
            else
            if s[i] in [#$c0..#$ff] then
                Result := Result + '%C3%' + IntToHex(Ord(s[i])-$40, 2)
            else
            if s[i] in [#$a0..#$bf] then
                Result := Result + '%C2%' + IntToHex(Ord(s[i]), 2)
            else
                Result := Result + s[i];
        end;
end;


end.

